# -*- coding: iso-8859-1 -*-
hinweis="""
# Nach dem Vorschlag
# GK Aufgabenbeispiel 2 - [667 kB] - 6.07.2005
# inf-gk-aufgabe-2.pdf
# nach Python bertragen
#
# StD Dipl.-Inform. Dr. rer. nat. L. Humbert
# 21., 20. August 2005
"""

from Verbindung import Verbindung
import os, string

class LiteraturServer:
    #
    def __init__(self,  pServerIP="192.168.0.1", pPort=10000, art="Server"):
        self.hatVerbindung= Verbindung(pServerIP, pPort, art)
        self.benutzerOK=False
        self.passwortOK=False
        self.wurzelverzeichnis=os.getcwd()
        self.aktuellesVerzeichnis=self.wurzelverzeichnis
        
        # ...

    # Sobald eine Anfrage eingeht, wird diese Methode aktiviert        
    def anfrageBearbeiten(self, daten=""):
        self.aktion, self.wert= daten.split(" ")[0],daten.split(" ")[1:]
        #print "to do:", self.aktion 
        #print "mit:", self.wert 

        if self.aktion=="USER":
            self.benutzer=self.wert[0]
            if self.benutzer=="humbert":
                self.hatVerbindung.sendeNachricht ("+Passwort eingeben")
                self.benutzerOK=True
            else:
                self.hatVerbindung.sendeNachricht ("Zugriff verweigert")
                self.beende()

        elif self.benutzerOK and  self.aktion=="PASS":
            if daten[5:]=="sag ich nicht":
                self.hatVerbindung.sendeNachricht ("+Zugriff gestattet")
                self.passwortOK=True
            else:
                self.hatVerbindung.sendeNachricht ("Zugriff verweigert")
                self.beende()

        elif self.aktion=="CD":
            # print "aktuelles Verzeichnis:", os.getcwd()
            try:
                #print  daten[3:]
                if daten[3:]=="..":
                    self.aktuellesVerzeichnis=string.join(self.aktuellesVerzeichnis.split("/")[:-1],"/") 
                else:    
                    self.aktuellesVerzeichnis=self.wurzelverzeichnis+"/SERVERDATEN/literatur/"+daten[3:]

                #print "Verzeichnis", self.aktuellesVerzeichnis
                
                os.chdir(self.aktuellesVerzeichnis)
                self.hatVerbindung.sendeNachricht ("+OK")
            except:    
                self.hatVerbindung.sendeNachricht ("Ordner nicht vorhanden")

        elif self.aktion=="LIST":
            try:
                verzeichnisinhalt=os.listdir(self.aktuellesVerzeichnis)
                self.hatVerbindung.sendeNachricht ("+OK")
                for eintrag in verzeichnisinhalt:
                    self.hatVerbindung.sendeNachricht ("#"+eintrag)
                self.hatVerbindung.sendeNachricht (">")
            except:    
                self.hatVerbindung.sendeNachricht ("Verzeichnisanzeige nicht mglich")

        elif self.aktion=="GET":
            dateiname=daten[4:]
            #print os.listdir(self.aktuellesVerzeichnis)
            try: 
                if dateiname in os.listdir(self.aktuellesVerzeichnis):
                    dateiinhalt=open(self.aktuellesVerzeichnis+"/"+dateiname,"r").readlines()
                    self.hatVerbindung.sendeNachricht ("+OK")
                    for zeile in dateiinhalt:
                        self.hatVerbindung.sendeNachricht ("#"+zeile)
                    self.hatVerbindung.sendeNachricht (">")    
                else:
                    self.hatVerbindung.sendeNachricht ("Datei nicht vorhanden")
            except:    
                self.hatVerbindung.sendeNachricht ("Datei nicht vorhanden")

        elif self.aktion=="BYE":
            self.hatVerbindung.sendeNachricht ("+BYE") 
            
        else:
            self.hatVerbindung.sendeNachricht ("-nicht implementiert")

    def beende(self):
        self.hatVerbindung.schliesse()



if __name__ == "__main__":
    print hinweis
    literaturServer= LiteraturServer ("192.168.0.1", 10000, art="Server")
    literaturServer.hatVerbindung.sendeNachricht ("+Willkommen")

    while 1:
        try:
            eingangsDaten=literaturServer.hatVerbindung.empfangeNachricht()  
            #print eingangsDaten, "von: ", literaturServer.hatVerbindung.getAbsender()[0],"Port:", literaturServer.hatVerbindung.getAbsender()[1]
            literaturServer.anfrageBearbeiten(eingangsDaten)
        except: 
            #print "Es werden keine Daten empfangen ..."
            break    

    literaturServer.beende()
    
    
    
    
    
