# -*- coding: iso-8859-1 -*-
hinweis="""
# Nach dem Vorschlag
# GK Aufgabenbeispiel 2 - [667 kB] - 6.07.2005
# inf-gk-aufgabe-2.pdf
# nach Python bertragen
#
# StD Dipl.-Inform. Dr. rer. nat. L. Humbert
# 21., 20. August 2005
"""
from Verbindung import Verbindung

class LiteraturClient :    
    def __init__(self,  pServerIP="", pPort=0, pBenutzer="", pPasswort="") :
        self.keineVerbindung= "Keine Verbindung zum Server"
        self.fehler=""
        
        try:
            self.hatVerbindung= Verbindung(pServerIP, pPort)
            nachricht= self.hatVerbindung.empfangeNachricht()
            ##print nachricht 

        except: 
            nachricht=None    
        
        if nachricht != None and nachricht[0]=="+":
            self.hatVerbindung.sendeNachricht("USER " + pBenutzer)
            nachricht = self.hatVerbindung.empfangeNachricht()
            if nachricht != None and nachricht[0] == '+':
                self.hatVerbindung.sendeNachricht("PASS " + pPasswort)
                nachricht = self.hatVerbindung.empfangeNachricht()
                # Keine Verbindung
                if nachricht == None:
                    self.fehler= self.keineVerbindung
                # Falsches pPasswort
                elif nachricht[0] == '-':
                    self.fehler= nachricht
            # Keine Verbindung
            elif  nachricht== None:
                self.fehler= self.keineVerbindung
            # Unbekannter pBenutzer
            elif  nachricht[0] == '-': 
                self.fehler= nachricht
        # Keine Verbindung
        elif  nachricht== None: 
            self.fehler= self.keineVerbindung                         
        # Nimmt keine Anfrage entgegen
        elif nachricht[0] == '-':
            self.fehler= nachricht
        
        
    def text(self, pAutor, pTitel) :    
        self.fehler=""
        txt=""
        nachricht=""
        
        self.hatVerbindung.sendeNachricht("CD "+pAutor)
        nachricht = self.hatVerbindung.empfangeNachricht()
        if nachricht[0] == '+':
            self.hatVerbindung.sendeNachricht("GET " + pTitel)
            nachricht = self.hatVerbindung.empfangeNachricht()
            # die folgenden Zeilen gegenber der Vorlage gendert
            # vgl. Verbindung.py
            if nachricht[0] == '+':
                while nachricht[-1:] != ">":
                    nachricht = self.hatVerbindung.empfangeNachricht()
                    txt = txt + nachricht                
                self.hatVerbindung.sendeNachricht("CD ..")
                nachricht = self.hatVerbindung.empfangeNachricht()
            else: #Datei nicht vorhanden
                self.fehler = nachricht
        else: # Verzeichnis nicht vorhanden
            self.fehler = nachricht
        return txt                    
        
    def autoren(self):
        autorenListe=""
        # Anfragen an den Server
        # ...
        # Aufbau der Liste
        # ...
        return autorenListe
    
    def titel(self, pAutor=""):
        titelListe=""
        # Anfragen an den Server
        # ...
        # Aufbau der Liste
        # ...        
        return titelListe
        
    def letzterFehler(self):
        return self.fehler

    def beende(self):
        if self.keineVerbindung==self.letzterFehler(): 
            return
        else:
            # "BYE" an Server, damit die Verbindung
            # ordentlich abgebaut wird
            self.hatVerbindung.sendeNachricht("BYE")
            nachricht=self.hatVerbindung.empfangeNachricht()
            if nachricht=="+BYE": 
                self.hatVerbindung.schliesse()
                return                
        self.hatVerbindung.schliesse()

if __name__ == "__main__":
    print hinweis
    literaturKlient= LiteraturClient ("192.168.0.1", 10000, "humbert", "sag ich nicht")
    print literaturKlient.text("Braumann","Infinite Didaktik")
    # ...
    # ...
    literaturKlient.beende()

    #print literaturKlient.letzterFehler()
    

