# -*- coding: iso-8859-1 -*-
hinweis="""
# Nach dem Vorschlag
# GK Aufgabenbeispiel 2 - [667 kB] - 6.07.2005
# inf-gk-aufgabe-2.pdf
# nach Python bertragen
#
# StD Dipl.-Inform. Dr. rer. nat. L. Humbert
# 21., 20. August 2005
"""
import socket, sys

serverProtokoll=True
serverProtokoll=False
protokoll=True
protokoll=False

def falschVerbunden():
    raise("Fehler: 'Art' ist weder 'Server' noch 'Client'.")
    sys.exit()

class Verbindung:
    def __init__(self, pServerIP="127.0.0.1", pPort=7890, art="Client"):
        self.art=art
        self.server= pServerIP
        self.absenderAdresse= self.server
        self.port= pPort

        self.sockel = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        
        if art == "Client":
            if protokoll: print "Zum Server",pServerIP, "ber den Port",pPort,"eine Verbindung etablieren ..."
            # socket -- Verbindung zum Server ffnen
            # ber diesen eingerichteten Mechanismus knnen Anfragen an den Server bermittelt werden
            # der sie ber diesen Kanal beantworten kann
            self.sockel.connect((self.server, self.port))
            
        elif art == "Server":
            if serverProtokoll: print "Server ( IP:",pServerIP,"Port:",pPort,") wartet auf Anfragen von Klienten ..."
            # socket -- Verbindung als Server ffnen und auf Anfragen warten
            # hiermit knnen  Anfragen ber den Port eingehen, die 
            # dann beantwortet werden (knnen)
            if serverProtokoll: print "self.sockel.bind((",self.server,",", self.port,"))"
            self.sockel.bind((self.server, self.port))
            if serverProtokoll: print "self.sockel.listen(5)"
            self.sockel.listen(5)   # max 5 Verbindungen
            self.verbindungVomClienten, self.absenderAdresse = self.sockel.accept()
            if serverProtokoll: print "self.absenderAdresse", self.absenderAdresse
            
        else: falschVerbunden()  


    def getAbsender(self):
        return self.absenderAdresse


    def sendeNachricht (self, pText=""):
        nachrichtAusgabe= '"'+pText+'" wird gesendet ...'
        if protokoll: print "sendeNachricht", nachrichtAusgabe
        if self.art=="Server": 
            self.verbindungVomClienten.send(pText)

        elif self.art=="Client":
            try:
                self.sockel.send(pText) 
            except:
                return "Nachricht konnte nicht gesendet werden."    

        else: falschVerbunden()        
    

        
    def empfangeNachricht(self):    
        if self.art=="Server":
            text= self.verbindungVomClienten.recv(1024) 
            return text
            
        elif self.art=="Client":
            text=self.sockel.recv(1024)
            if protokoll: print "Client: empfangeNachricht", text 

        else: falschVerbunden()        
            
        return text
        
    def schliesse(self):    
        if self.art== "Client":
            if protokoll: print "Baue Verbindung zum Server:",self.server,"an Port",self.port,"ab."
        elif self.art== "Server": 
            if serverProtokoll: print "Schliee Port:",self.port,"auf dem Server:",self.server
            self.verbindungVomClienten.close()
        else: falschVerbunden() 
        self.sockel.close()

if __name__ == "__main__":
    print hinweis
